<form novalidate #f="ngForm" (ngSubmit)="onSubmit()">
  <table>
    <tr>
      <th>Name</th>
      <td>
        <input type="text" name="name" [(ngModel)]="user.name" #name="ngModel"
               required minlength="5" />
      </td>
      <td>
        <ul *ngIf="name.dirty && name.invalid">
          <li *ngIf="name.errors.required">Must not be empty</li>
          <li *ngIf="name.errors.minlength">At least 5 chars</li>
        </ul>
      </td>
    </tr>

    <tr>
      <th>Age</th>
      <td>
        <input type="number" name="age" [(ngModel)]="user.age" #age="ngModel"
               min="18" max="100" />
      </td>
      <td>
        <ul *ngIf="age.dirty && age.invalid">
          <li *ngIf="age.errors.min">Must be 18 or older</li>
          <li *ngIf="age.errors.max">Must be less than 100</li>
        </ul>
      </td>
    </tr>

    <tr>
      <th>Date</th>
      <td>
        <input type="date" name="created" [(ngModel)]="user.created" #created="ngModel"
               required />
      </td>
      <td>
        <ul *ngIf="created.dirty && created.invalid">
          <li *ngIf="created.errors.required">Must not be empty</li>
        </ul>
      </td>
    </tr>

    <tr>
      <th></th>
      <td>
        <button type="submit" [disabled]="f.form.invalid">REGISTER</button>
      </td>
      <td></td>
    </tr>
  </table>
</form>
